' Letzte Bearbeitung : 22.12.1992   15:00

'  Turbo - B A S I C -  B I B L I O T H E K   fr die Makrobefehle

'  des SPB-Moduls M-SIO-8 von SORCUS COMPUTER GmbH

'  Version 1B (Z80-I/O-Befehle)    (nderungen vorbehalten)

$INCLUDE "C:\HK\ML4lib\ML4lib.bas"


'  Globale Variable



CCTS% = 0    ' CTS-Pegel
CRTS% = 0    ' RTS-Pegel
TRUE =  1    ' wahr	
FALSE = 0    ' falsch

' Initialisierung eines Kanals auf dem SPB-Modul M-SIO-8

SUB ml4initsio8(modul%,kanal%,rbaud%,tbaud%,laenge%,stopb%,parity%,cts%,rts%)
LOCAL cmd%,err1%,zwivar%
SHARED ml4ferr%,CCTS%,CRTS%

  if (modul% > 0) and (modul% < 5) then
      cmd% = ((modul% - 1) * &H20) + &H80             ' Befehlscode ermitteln
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+8,kanal%*2)     ' KAR = kanal%*2
      zwivar% = &H35                                  ' Transmitter enable, Receiver enable,
                                                      ' RESET Error, Receiver Interrupt enabled,
                                                      ' Transmitter Interrupt disabled,
                                                      ' Kein Transmit Break, Betriebsart normal

      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+3,zwivar%)      ' KCR = zwivar%
      zwivar% = 0
      select case stopb%                              ' Stop-Bits
        case 1 : zwivar% = &H40                       ' 1 Stop-Bit
        case 2 : zwivar% = &HC0                       ' 2 Stop-Bits
        case 5 : zwivar% = &H80                       ' 1,5 Stop-Bits
      end select
      select case parity%                             ' Paritt
        case 1 : zwivar% = zwivar% + &H10             ' ungerade Paritt
        case 2 : zwivar% = zwivar% + &H30             ' gerade Paritt
        case 0 : zwivar% = zwivar% + &H00             ' keine Paritt
      end select
      select case laenge%                             ' Lnge
        case 5 : zwivar% = zwivar% + &H00             ' 5 Bit
        case 6 : zwivar% = zwivar% + &H04             ' 6 Bit
        case 7 : zwivar% = zwivar% + &H08             ' 7 Bit
        case 8 : zwivar% = zwivar% + &H0C             ' 8 Bit
      end select
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+2,zwivar%)      ' MR1 = zwivar%
      zwivar% = 0
      select case rbaud%                              ' Empfangs-Baudrate
        case 50    : zwivar% = &H00
        case 75    : zwivar% = &H01
        case 110   : zwivar% = &H02
        case 134   : zwivar% = &H03
        case 150   : zwivar% = &H04
        case 300   : zwivar% = &H05
        case 600   : zwivar% = &H06
        case 1200  : zwivar% = &H07
        case 1800  : zwivar% = &H08
        case 2000  : zwivar% = &H09
        case 2400  : zwivar% = &H0A
        case 3600  : zwivar% = &H0B
        case 4800  : zwivar% = &H0C
        case 7200  : zwivar% = &H0D
        case 9600  : zwivar% = &H0E
        case 19200 : zwivar% = &H0F
      end select
      select case tbaud%                              ' Sende-Baudrate
        case 50    : zwivar% = zwivar% + &H00
        case 75    : zwivar% = zwivar% + &H10
        case 110   : zwivar% = zwivar% + &H20
        case 134   : zwivar% = zwivar% + &H30
        case 150   : zwivar% = zwivar% + &H40
        case 300   : zwivar% = zwivar% + &H50
        case 600   : zwivar% = zwivar% + &H60
        case 1200  : zwivar% = zwivar% + &H70
        case 1800  : zwivar% = zwivar% + &H80
        case 2000  : zwivar% = zwivar% + &H90
        case 2400  : zwivar% = zwivar% + &HA0
        case 3600  : zwivar% = zwivar% + &HB0
        case 4800  : zwivar% = zwivar% + &HC0
        case 7200  : zwivar% = zwivar% + &HD0
        case 9600  : zwivar% = zwivar% + &HE0
        case 19200 : zwivar% = zwivar% + &HF0
      end select
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+2,zwivar%)      ' MR2 = zwivar%
      CCTS% = cts%
      CRTS% = rts%
      err1% = ml4ferr%
  else                                                ' Falscher Steckplatz
    err1% = 20
  end if
  ml4ferr% = err1%
end SUB

' Lies Interrupt-Status-Register auf dem Modul M-SIO-8

SUB ml4sio8getint(modul%,inter%,kanal%)
LOCAL cmd%,stat%,err1%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
      cmd% = ((modul% - 1) * &H20) + &H80             ' Befehlscode ermitteln
      if ml4ferr% = 0 then_
        call ml4inport(ml4ferr%,stat%,cmd%+4)         ' ISR lesen
      err1% = ml4ferr%
      if (stat% and &H80) = &H80 then                 ' Interrupt-Request ?
        kanal% = (stat% and &H0E) \ 2                 ' Kanal ermitteln
        inter% = TRUE                                 ' Interrupt-Anforderung liegt vor
      else
        kanal% = 0                                    ' Default-Zuweisung
        inter% = FALSE                                ' Keine Interrupt-Anforderung
      end if
  else                                                ' Falscher Steckplatz
      err1% = 20
  end if
  ml4ferr% = err1%
end SUB


' Lies Status eines Kanals des SPB-Moduls M-SIO-8

DEF FNml4sio8gets%(modul%,kanal%)
LOCAL cmd%,data1%,err1%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
      cmd% = ((modul% - 1) * &H20) + &H80             ' Befehlscode ermitteln
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+8,kanal%*2)     ' KAR = kanal%*2
      if ml4ferr% = 0 then_
        call ml4inport(ml4ferr%,data1%,cmd%+1)        ' data1 = KSR
      err1% = ml4ferr%
      FNml4sio8gets% = data1% and &HBB
  else                                                ' Falscher Steckplatz
      err1% = 20
      FNml4sio8gets% = 0
  end if
  ml4ferr% = err1%
end DEF

' Senden eines Zeichens ber einen Kanal des SPB-Moduls M-SIO-8

SUB ml4sio8tmt(modul%,kanal%,zeichen$)
LOCAL cmd%,data1%,err1%,zustand%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
      cmd% = ((modul% - 1) * &H20) + &H80             ' Befehlscode ermitteln
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+8,kanal%*2)     ' KAR = kanal%*2
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%,ASC(zeichen$))  ' KDR = zeichen
      err1% = ml4ferr%
  else                                                ' Falscher Steckplatz
    err1% = 20
  end if
  ml4ferr% = err1%
end SUB

' Empfangen eines Zeichens ber einen Kanal des SPB-Moduls M-SIO-8

DEF FNml4sio8rcvb$(modul%,kanal%,status%)
LOCAL cmd%,data1%,err1%,loop1%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
      cmd% = ((modul% - 1) * &H20) + &H80             ' Befehlscode ermitteln
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+8,kanal%*2)     ' KAR = kanal%*2
      data1% = 0
      if ml4ferr% = 0 then_
        call ml4inport(ml4ferr%,data1%,cmd%+1)         ' KSR lesen
      if (data1% and 2) = 2 then                       ' Character Received ?
        call ml4sio80rts(modul%,kanal%)
        if ml4ferr% = 0 then_
          call ml4inport(ml4ferr%,data1%,cmd%)         ' data1 = RDR
      else
        loop1% = 0
        call ml4sio81rts(modul%,kanal%)
        While not (((data1% and 2) = 2) or (loop1% = 1000))
          if ml4ferr% = 0 then_
            call ml4inport(ml4ferr%,data1%,cmd%+1)       ' KSR lesen
          loop1% = loop1% + 1
        wend
        if (data1% and 2) = 2 then
          if ml4ferr% = 0 then_
            call ml4inport(ml4ferr%,data1%,cmd%)         ' data1 = RDR
        else
          data1% = 0
        end if
      end if
      if ml4ferr% = 0 then_
        call ml4inport(ml4ferr%,status%,cmd%+1)          ' KSR lesen
      if loop1%  = 1000 then
        status% = status% and &HBB
      else
        status% = status% and &H0B
      end if
      err1% = ml4ferr%
      FNml4sio8rcvb$ = chr$(data1%)
  else                                                ' Falscher Steckplatz
      err1% = 20
      FNml4sio8rcvb$ = chr$(0)
  end if
  ml4ferr% = err1%
end DEF

' Clear Error-Status des SPB-Moduls M-SIO-8

SUB ml4sio8clr(modul%,kanal%)
LOCAL cmd%,data1%,err1%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
      cmd% = ((modul% - 1) * &H20) + &H80             ' Befehlscode ermitteln
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+8,kanal%*2)     ' KAR = kanal%*2
      if ml4ferr% = 0 then_
        call ml4inport(ml4ferr%,data1%,cmd%+3)        ' KCR lesen
      data1% = data1% or &H10                         ' Error-Bit = 1 setzen
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+3,data1%)       ' KCR = data1
      err1% = ml4ferr%
  else                                                ' Falscher Steckplatz
    err1% = 20
  end if
  ml4ferr% = err1%
end SUB

' Setze Transmit Break des SPB-Moduls M-SIO-8

SUB ml4sio8brk(modul%,kanal%)
LOCAL cmd%,data1%,err1%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
      cmd% = ((modul% - 1) * &H20) + &H80             ' Befehlscode ermitteln
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+8,kanal%*2)     ' KAR = kanal%*2
      if ml4ferr% = 0 then_
        call ml4inport(ml4ferr%,data1%,cmd%+3)        ' KCR lesen
      data1% = data1% or &H08                         ' Transmit Break = 1 setzen
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+3,data1%)       ' KCR = data1
      err1% = ml4ferr%
  else                                                ' Falscher Steckplatz
    err1% = 20
  end if
  ml4ferr% = err1%
end SUB

' Hebe Transmit Break des SPB-Moduls M-SIO-8 auf

SUB ml4sio8ubrk(modul%,kanal%)
LOCAL cmd%,data1%,err1%
SHARED ml4ferr%

  if (modul% > 0) and (modul% < 5) then
      cmd% = ((modul% - 1) * &H20) + &H80             ' Befehlscode ermitteln
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+8,kanal%*2)     ' KAR = kanal%*2
      if ml4ferr% = 0 then_
        call ml4inport(ml4ferr%,data1%,cmd%+3)        ' KCR lesen
      data1% = data1% and &HF7                        ' Transmit Break = 0 setzen
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+3,data1%)       ' KCR = data1
      err1% = ml4ferr%
  else                                                ' Falscher Steckplatz
    err1% = 20
  end if
  ml4ferr% = err1%
end SUB

' Setzen der RTS-Leitung eines Kanals des SPB-Moduls M-SIO-8 = 0

SUB ml4sio80rts(modul%,kanal%)
LOCAL cmd%,err1%
SHARED ml4ferr%,CRTS%

  if (modul% > 0) and (modul% < 5) then
      cmd% = ((modul% - 1) * &H20) + &H80             ' Befehlscode ermitteln
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+8,kanal%*2)     ' KAR = kanal%*2
      cmd% = cmd% + &H10 + (kanal%*2) + (1 - CRTS%)
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%,0)              ' RTS = 0
      err1% = ml4ferr%
  else                                                ' Falscher Steckplatz
    err1% = 20
  end if
  ml4ferr% = err1%
end SUB


' Setzen der RTS-Leitung eines Kanals des SPB-Moduls M-SIO-8 = 1

SUB ml4sio81rts(modul%,kanal%)
LOCAL cmd%,err1%
SHARED ml4ferr%,CRTS%

  if (modul% > 0) and (modul% < 5) then
      cmd% = ((modul% - 1) * &H20) + &H80             ' Befehlscode ermitteln
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%+8,kanal%*2)     ' KAR = kanal%*2
      cmd% = cmd% + &H10 + (kanal%*2) + CRTS%
      if ml4ferr% = 0 then_
        call ml4outport(ml4ferr%,cmd%,0)              ' RTS = 1
      err1% = ml4ferr%
  else                                                ' Falscher Steckplatz
    err1% = 20
  end if
  ml4ferr% = err1%
end SUB


