/* Letzte Bearbeitung : 22.12.1992   15:20  */

/*

   C  -  B I B L I O T H E K   fr die Makrobefehle

   des SPB-Moduls M-SIO-8 von SORCUS COMPUTER GmbH

   Version 1E (Z80-I/O-Befehle)    (nderungen vorbehalten)

*/

extern m4write();
extern m4read();
extern m4outp();
extern m4inp();
extern int m4adr;
extern m4err;

/*
  Globale Variable
                  */

int CCTS;    /* CTS-Pegel */
int CRTS;    /* RTS-Pegel */

#define true  0x01;
#define false 0x00;

/* Initialisierung eines Kanals auf dem SPB-Modul M-SIO-8 */

m4inisio8(modul,kanal,rbaud,tbaud,laenge,stopb,parity,cts,rts)
char modul,kanal;
int rbaud,tbaud;
char laenge,stopb,parity,cts,rts;
{
  int cmd,err1,zwivar;

  if ((modul > 0) && (modul < 5)) {
      cmd = ((modul - 1) * 0x20) + 0x80;                       /* Befehlscode ermitteln */
      if (m4err == 0) m4outp(&m4err,cmd+8,kanal*2);            /* KAR = kanal*2 */
      zwivar = 0x35;                                           /* Transmitter enable, Receiver enable,
                                                                  RESET Error, Receiver Interrupt enabled,
                                                                  Transmitter Interrupt disabled,
                                                                  Kein Transmit Break, Betriebsart normal */

      if (m4err == 0) m4outp(&m4err,cmd+3,zwivar);             /* KCR = zwivar */
      zwivar = 0;
      switch(stopb) {                                          /* Stop-Bits */
      case 1 : zwivar = 0x40; break;                           /* 1 Stop-Bit */
      case 2 : zwivar = 0xC0; break;                           /* 2 Stop-Bits */
      case 5 : zwivar = 0x80; break;                           /* 1,5 Stop-Bits */
        }
      switch(parity) {                                         /* Paritt */
      case 0 : zwivar = zwivar + 0x00; break;                  /* keine Paritt */
      case 1 : zwivar = zwivar + 0x10; break;                  /* ungerade Paritt */
      case 2 : zwivar = zwivar + 0x30; break;                  /* gerade Paritt */
        }
      switch(laenge) {                                         /* Lnge */
      case 5 : zwivar = zwivar + 0x00; break;                  /* 5 Bit */
      case 6 : zwivar = zwivar + 0x04; break;                  /* 6 Bit */
      case 7 : zwivar = zwivar + 0x08; break;                  /* 7 Bit */
      case 8 : zwivar = zwivar + 0x0C; break;                  /* 8 Bit */
        }
      if (m4err == 0) m4outp(&m4err,cmd+2,zwivar);             /* MR1 = zwivar */
      zwivar = 0;
      switch(rbaud) {                                          /* Empfangs-Baudrate */
      case 50    : zwivar = 0x00; break;
      case 75    : zwivar = 0x01; break;
      case 110   : zwivar = 0x02; break;
      case 134   : zwivar = 0x03; break;
      case 150   : zwivar = 0x04; break;
      case 300   : zwivar = 0x05; break;
      case 600   : zwivar = 0x06; break;
      case 1200  : zwivar = 0x07; break;
      case 1800  : zwivar = 0x08; break;
      case 2000  : zwivar = 0x09; break;
      case 2400  : zwivar = 0x0A; break;
      case 3600  : zwivar = 0x0B; break;
      case 4800  : zwivar = 0x0C; break;
      case 7200  : zwivar = 0x0D; break;
      case 9600  : zwivar = 0x0E; break;
      case 19200 : zwivar = 0x0F; break;
        }
      switch(tbaud) {                                          /* Sende-Baudrate */
      case 50    : zwivar = zwivar + 0x00; break;
      case 75    : zwivar = zwivar + 0x10; break;
      case 110   : zwivar = zwivar + 0x20; break;
      case 134   : zwivar = zwivar + 0x30; break;
      case 150   : zwivar = zwivar + 0x40; break;
      case 300   : zwivar = zwivar + 0x50; break;
      case 600   : zwivar = zwivar + 0x60; break;
      case 1200  : zwivar = zwivar + 0x70; break;
      case 1800  : zwivar = zwivar + 0x80; break;
      case 2000  : zwivar = zwivar + 0x90; break;
      case 2400  : zwivar = zwivar + 0xA0; break;
      case 3600  : zwivar = zwivar + 0xB0; break;
      case 4800  : zwivar = zwivar + 0xC0; break;
      case 7200  : zwivar = zwivar + 0xD0; break;
      case 9600  : zwivar = zwivar + 0xE0; break;
      case 19200 : zwivar = zwivar + 0xF0; break;
        }
      if (m4err == 0) m4outp(&m4err,cmd+2,zwivar);             /* MR2 = zwivar */
      CCTS = cts;
      CRTS = rts;
      err1 = m4err;
    }
  else                                                         /* Falscher Steckplatz */
    err1 = 20;
  m4err = err1;
}

/* Lies Interrupt-Status-Register auf dem Modul M-SIO-8 */

m4sio8gint(modul, inter, kanal)
char modul, *inter, *kanal;
{
  int cmd, stat, err1;

  if ((modul > 0) && (modul < 5)) {
      cmd = ((modul - 1) * 0x20) + 0x80;                       /* Befehlscode ermitteln */
      if (m4err == 0) m4inp(&m4err,&stat,cmd+4);               /* ISR lesen */
      err1 = m4err;
      if ((stat & 0x80) == 0x80) {                             /* Interrupt-Request ? */
        *kanal = (stat & 0x0F) >> 1;                           /* Kanal ermitteln */
        *inter = true;                                         /* Interrupt-Anforderung liegt vor */
        }
      else {
        *kanal = 0;                                            /* Default-Zuweisung */
        *inter = false;                                        /* Keine Interrupt-Anforderung */
        }
    }
  else                                                         /* Falscher Steckplatz */
    {
      err1 = 20;
    }
  m4err = err1;
}


/* Lies Status eines Kanals des SPB-Moduls M-SIO-8 */

m4sio8gets(modul,kanal)
char modul, kanal;
{
  int cmd,data,err1;

  if ((modul > 0) && (modul < 5)) {
      cmd = ((modul - 1) * 0x20) + 0x80;                       /* Befehlscode ermitteln */
      if (m4err == 0) m4outp(&m4err,cmd+8,kanal*2);            /* KAR = kanal*2 */
      if (m4err == 0) m4inp(&m4err,&data,cmd+1);               /* data = KSR */
      err1 = m4err;
      return(data & 0xBB);
    }
  else                                                         /* Falscher Steckplatz */
    {
      err1 = 20;
      return(0);
    }
  m4err = err1;
}

/* Senden eines Zeichens ber einen Kanal des SPB-Moduls M-SIO-8 */

m4sio8tmt(modul,kanal,zeichen)
char modul,kanal,zeichen;
{
     int cmd, data, err1, zustand;

  if ((modul > 0) && (modul < 5)) {
      cmd = ((modul - 1) * 0x20) + 0x80;                       /* Befehlscode ermitteln */
      if (m4err == 0) m4outp(&m4err,cmd+8,kanal*2);            /* KAR = kanal*2 */
      if (m4err == 0) {
        m4outp(&m4err,cmd,zeichen);                            /* KDR = zeichen */
      }
      err1 = m4err;
    }
  else {                                                       /* Falscher Steckplatz */
    err1 = 20;
  }
  m4err = err1;
}

/* Empfangen eines Zeichens ber einen Kanal des SPB-Moduls M-SIO-8 */

char m4sio8rcvb(modul, kanal, status)
char modul, kanal, *status;
{
  int cmd,loop1,data,err1;

  if ((modul > 0) && (modul < 5)) {
      cmd = ((modul - 1) * 0x20) + 0x80;                       /* Befehlscode ermitteln */
      if (m4err == 0) m4outp(&m4err,cmd+8,kanal*2);            /* KAR = kanal*2 */
      if (m4err == 0) m4inp(&m4err,&data,cmd+1);               /* KSR lesen */
      if ((data & 2) == 2) {
        m4sio80rts(modul,kanal);
        if (m4err == 0) m4inp(&m4err,&data,cmd);               /* data = RDR */
        }
      else {
        loop1 = 0;
        m4sio81rts(modul,kanal);
        do {
          if (m4err == 0) m4inp(&m4err,&data,cmd+1);           /* KSR lesen */
          loop1 += 1;
        } while (((data & 2) != 2) | (loop1 != 1000));         /* Character Received ? */
        if ((data & 2) == 2) {
          if (m4err == 0) m4inp(&m4err,&data,cmd);             /* data = RDR */
          }
        else
          data = 0;
      }
      if (m4err == 0) m4inp(&m4err,status,cmd+1);              /* KSR lesen */
      if (loop1 == 1000 ) *status = (*status & 0x0B);
      else *status = (*status & 0xBB);
      err1 = m4err;
      return(data);
    }
  else                                                         /* Falscher Steckplatz */
    {
      err1 = 20;
      return(0);
    }
  m4err = err1;
}

/* Clear Error-Status des SPB-Moduls M-SIO-8 */

m4sio8clr(modul, kanal)
char modul, kanal;
{
     int cmd, data, err1;

  if ((modul > 0) && (modul < 5)) {
      cmd = ((modul - 1) * 0x20) + 0x80;                       /* Befehlscode ermitteln */
      if (m4err == 0) m4outp(&m4err,cmd+8,kanal*2);            /* KAR = kanal*2 */
      if (m4err == 0) m4inp(&m4err,&data,cmd+3);               /* KCR lesen */
      data = data | 0x10;                                      /* Error-Bit = 1 setzen */
      if (m4err == 0) m4outp(&m4err,cmd+3,data);               /* KCR = data */
      err1 = m4err;
    }
  else                                                         /* Falscher Steckplatz */
    err1 = 20;
  m4err = err1;
}

/* Setze Transmit Break des SPB-Moduls M-SIO-8 */

m4sio8brk(modul,kanal)
char modul,kanal;
{
  int cmd,data,err1;

  if ((modul > 0) && (modul < 5))
    {
      cmd = ((modul - 1) * 0x20) + 0x80;                       /* Befehlscode ermitteln */
      if (m4err == 0) m4outp(&m4err,cmd+8,kanal*2);            /* KAR = kanal*2 */
      if (m4err == 0) m4inp(&m4err,&data,cmd+3);               /* KCR lesen */
      data = data | 0x08;                                      /* Transmit Break = 1 setzen */
      if (m4err == 0) m4outp(&m4err,cmd+3,data);               /* KCR = data */
      err1 = m4err;
    }
  else                                                         /* Falscher Steckplatz */
    err1 = 20;
  m4err = err1;
}

/* Hebe Transmit Break des SPB-Moduls M-SIO-8 auf */

m4sio8ubrk(modul,kanal)
char modul,kanal;

{
  int cmd,data,err1;

  if ((modul > 0) && (modul < 5))
    {
      cmd = ((modul - 1) * 0x20) + 0x80;                       /* Befehlscode ermitteln */
      if (m4err == 0) m4outp(&m4err,cmd+8,kanal*2);            /* KAR = kanal*2 */
      if (m4err == 0) m4inp(&m4err,&data,cmd+3);               /* KCR lesen */
      data = data & 0xF7;                                      /* Transmit Break = 0 setzen */
      if (m4err == 0) m4outp(&m4err,cmd+3,data);               /* KCR = data */
      err1 = m4err;
    }
  else                                                         /* Falscher Steckplatz */
    err1 = 20;
  m4err = err1;
}

/* Setzen der RTS-Leitung eines Kanals des SPB-Moduls M-SIO-8 = 0 */

m4sio80rts(modul,kanal)
char modul,kanal;

{
 int cmd,err1;

  if ((modul > 0) && (modul < 5))
    {
      cmd = ((modul - 1) * 0x20) + 0x80;                       /* Befehlscode ermitteln */
      if (m4err == 0) m4outp(&m4err,cmd+8,kanal*2);            /* KAR = kanal*2 */
      cmd = cmd + 0x10 + (kanal*2) + (1 - CRTS);
      if (m4err == 0) m4outp(&m4err,cmd,0);                    /* RTS = 0 */
      err1 = m4err;
    }
  else                                                         /* Falscher Steckplatz */
    err1 = 20;
  m4err = err1;
}


/* Setzen der RTS-Leitung eines Kanals des SPB-Moduls M-SIO-8 = 1 */

m4sio81rts(modul,kanal)
char modul,kanal;

{
 int cmd,err1;

  if ((modul > 0) && (modul < 5))
    {
      cmd = ((modul - 1) * 0x20) + 0x80;                       /* Befehlscode ermitteln */
      if (m4err == 0) m4outp(&m4err,cmd+8,kanal*2);            /* KAR = kanal*2 */
      cmd = cmd + 0x10 + (kanal*2) + CRTS;
      if (m4err == 0) m4outp(&m4err,cmd,0);                    /* RTS = 1 */
      err1 = m4err;
    }
  else                                                         /* Falscher Steckplatz */
    err1 = 20;
  m4err = err1;
}









